/*
 * Copyright (c) 1999 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/*
 * Credentials: as of yet ill-defined
 *
 * XXX dealing with resources here may be way off base.
 */
#ifndef _CREDENTIAL_IMPL_H_
#define _CREDENTIAL_IMPL_H_

#include "resource.h"

struct credential {
	void		*stuff;		/* XXX authentication stuff */
	struct resource	current;	/* resources allotted to this "user" */
	struct resource limits;		/* resource limits for this "user" */
};
typedef struct credential credential_t;

/* credential_check operations */
#define CCHECK_FLOW_CREATE	1

/* credential_check returns */
#define CCHECK_OK	0
#define CCHECK_FAIL	1

struct cpuspec;
struct memspec;

void credential_init(void);
struct credential *credential_create(void *stuff, struct resource *limits);
void credential_destroy(struct credential *cred);
int credential_check(struct credential *cred, int op, ...);
int credential_resource_alloc(struct credential *cred, struct resource *res); 
int credential_resource_free(struct credential *cred, struct resource *res);
struct credential *credential_current(void);

#endif /* _CREDENTIAL_IMPL_H_ */
