/*
 * Copyright (c) 1999 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/*
 * Accounted memory allocation for all NodeOS data structs.
 *
 * XXX need to hook into osenv_mem interface for OSKit components.
 * XXX for now we just charge all allocation to the root_mempool.
 */
#include <assert.h>

#include "mempool.h"
#include "mem.h"

void
mem_init(void)
{
}

void *
mem_alloc(size_t size)
{
	return mempool_alloc(mempool_current(), size);
}

void mem_free(void *ptr, size_t size)
{
	/*
	 * XXX using mempool_current could be a problem if flows with
	 * different mempools can share NodeOS objects.  Then we could
	 * have one pool charged for the allocation and another credited
	 * for deallocation.
	 */
	mempool_free(mempool_current(), ptr, size);
}
