/*
 * Copyright (c) 1999 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

#ifndef _UNIX_ETH_IMPL_H_
#define _UNIX_ETH_IMPL_H_

#include <netinet/if_ether.h>

struct if_info {
	unsigned char name[IFNAMSIZ];
	unsigned char addr[6];
};


int unix_eth_get_if_info(struct if_info **nfo);

int os_open_eth(char *dev);
int os_read_packet(int fd, char *buf, int bufsize);
int os_write_packet(int fd, char *buf, int bufsize, struct ether_header *eh);

#endif /* _UNIX_ETH_IMPL_H_ */

